﻿// --------------------------------------------------------------------------------------
//
// CDMain.cs                                                      Ulrich Müller  29.12.07
//                                                                PCS1700 C# 2005 Express
//   Modell CD-Player aus Profi Computing von 1991
//      Die Datenscheibe hat 3 Spuren mit je 25 Segmenten = 75 Datenbits
//      Nach Start des Programmes werden alle Daten nach Datenfeld eingelesen
//      und dann geschlossen abgespielt dabei werden jeweils 4 bits zu einem Ton 
//      zusammengefaßt(so sind 15 verschiedene Töne + Ruhe möglich).
//      --- Basis ist die Assembly FishFace2005.DLL
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace FishFaceWindowsCS1 {
  public partial class frmMain : Form {
    FishFace ft = new FishFace();
    bool[] Datenfeld = new bool[75];

    private void Action() {
      CDInit();
      ScheibeLesen();
      TonfolgeErzeugen();
    }

    private void CDInit() {
      ft.SetMotor(Out.M3, Dir.Ein);
      ft.SetMotor(Out.M1, Dir.Rechts);
      ft.SetMotor(Out.M2, Dir.Links);
      ft.WaitForInput(Inp.I4, false);
      ft.SetMotor(Out.M2, Dir.Rechts);
      ft.WaitForInput(Inp.I4);
      ft.SetMotor(Out.M2, Dir.Aus);
      ft.WaitForHigh(Inp.I1);
      for(int i = 0; i < Datenfeld.Length; i++) Datenfeld[i] = false;
    }
    private void ScheibeLesen() {
      for (int i = 0; i < 25; i++) {
        Datenfeld[i] = !ft.GetInput(Inp.I5);
        ft.WaitForChange(Inp.I2, 16);
      }
      ft.SetMotor(Out.M1, Dir.Aus);

      ft.SetMotor(Out.M2, Dir.Links);
      ft.WaitForChange(Inp.I3, 26);
      ft.SetMotor(Out.M2, Dir.Aus);

      ft.SetMotor(Out.M1, Dir.Rechts);
      for(int i = 25; i < 50; i++){
        Datenfeld[i] = !ft.GetInput(Inp.I5);
        ft.WaitForChange(Inp.I2, 16);
      }
      ft.SetMotor(Out.M1, Dir.Aus);

      ft.SetMotor(Out.M2, Dir.Links);
      ft.WaitForChange(Inp.I3, 26);
      ft.SetMotor(Out.M2, Dir.Aus);

      ft.SetMotor(Out.M1, Dir.Rechts);
      for (int i = 50; i < 75; i++) {
        Datenfeld[i] = !ft.GetInput(Inp.I5);
        ft.WaitForChange(Inp.I2, 16);
      }
      ft.SetMotor(Out.M1, Dir.Aus);
      ft.SetMotor(Out.M3, Dir.Aus);
      ft.SetMotor(Out.M2, Dir.Rechts);
      ft.WaitForInput(Inp.I4);
      ft.SetMotor(Out.M2, Dir.Aus);
    }
    private void TonfolgeErzeugen() {
      int Frequenz;
      int i = 0;
      do{
        Frequenz = 0;
        if (Datenfeld[i])     Frequenz += 8;
        if (Datenfeld[i + 1]) Frequenz += 4;
        if (Datenfeld[i + 2]) Frequenz += 2;
        if (Datenfeld[i + 3]) Frequenz += 1;
        if (ft.Finish()) return;
        if (Frequenz > 0) Console.Beep(Frequenz * 100, 600);
        else ft.Pause(600);
        i += 4;
      }while(i < 71); 
    }

    #region --- Programm-Kontrolle ---
    public frmMain() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      // --- Open erstes ROBO an USB oder Intelligent Interface an COM
      //     während des Ablaufs von Action() gesperrt ---------------
      try {
        if (cboPortName.SelectedIndex == 0)
          ft.OpenInterface(IFTypen.ftROBO_first_USB, 0);
        else ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5);
        cmdAction.Enabled = false;
        cmdEnde.Text = "&HALT";
        lblStatus.Text = "--- Bei der Arbeit ---";
        lblHinweis.Text = "--- Ende : HALT-Button oder ESC-Taste ---";

        Action();        // --- Haupt-Routine der Anwendung

        ft.ClearMotors();
      }
      catch (FishFaceException eft) {
        MessageBox.Show(eft.Message, this.Text,
          MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
      finally {
        ft.CloseInterface();
        cmdAction.Enabled = true;
        cmdEnde.Text = "&ENDE";
        lblStatus.Text = "--- Auf ein Neues ---";
        lblHinweis.Text = "Nochmal : ACTION, sonst ENDE oder ESC-Taste";
        cmdAction.Focus();
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      // --- Programmende nur, wenn Action nicht läuft ---
      if (cmdEnde.Text == "&HALT") ft.NotHalt = true; else this.Close();
    }

    private void formLoad(object sender, EventArgs e) {
      // --- Default-Interface : Erstes ROBO Interface an USB ----
      cboPortName.SelectedIndex = 0;
    }

    private void formClosing(object sender, FormClosingEventArgs e) {
      // --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ------
      if (cmdEnde.Text == "&HALT") e.Cancel = true;
    }
    #endregion
  }
}