﻿' -----------------------------------------------------------------------------------------
'
' CDPlayerLuxus.vb                                                  Ulrich Müller  02.01.08
'                                                                   PCS1700 VB 2005 Express
' Luxus-Version des CD-Players aus Profi Computing 1991
'               Basis ist die Assembly FishFace2005.DLL
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFace40

Public Class frmMainLuxus

  Dim ft As New FishFace()
  Dim Datenfeld(75) As Integer

  Const mScheibe As Out = Out.M1
  Const mLeseSchlitten As Out = Out.M2
  Const mLeseLampe As Out = Out.M3

  Const iScheibeNull As Inp = Inp.I1
  Const iScheibeImpuls As Inp = Inp.I2
  Const iLesenImpuls As Inp = Inp.I3
  Const iLesenEnde As Inp = Inp.I4
  Const iLeseKopf As Inp = Inp.I5
  Const dVor As Dir = Dir.Links
  Const dRueck As Dir = Dir.Rechts

  Private Sub Action()
    ' --- Initialisierung ----
    lblStatus.Text = "Initialisierung gestartet"
    ft.SetMotor(mLeseLampe, Dir.Ein)
    ft.SetMotor(mScheibe, Dir.Rechts)
    ft.SetMotor(mLeseSchlitten, dVor)
    ft.WaitForInput(iLesenEnde, False)
    ft.SetMotor(mLeseSchlitten, dRueck)
    ft.WaitForInput(iLesenEnde)
    ft.SetMotor(mLeseSchlitten, Dir.Aus)
    ft.WaitForInput(iScheibeNull)
    ft.SetMotor(mScheibe, Dir.Aus)
    picFisch.Visible = False
    lstWerte.Visible = True
    lstWerte.Items.Clear()

    ' --- Scheibe Lesen ------
    ScheibeLesen(0)
    ScheibeLesen(1)
    ScheibeLesen(2)
    lblStatus.Text = "Rückstellung"
    ft.SetMotor(mLeseLampe, Dir.Aus)
    ft.SetMotor(mLeseSchlitten, dRueck)
    ft.WaitForInput(iLesenEnde)
    ft.SetMotor(mLeseSchlitten, Dir.Aus)

    ' --- Tonfolge wiedergeben ----
    Dim Frequenz As Integer
    Dim d As Integer = 0
    Dim Kode As String
    lstWerte.Items.Add("Dekodierte Töne")
    Do
      Frequenz = (Datenfeld(d) * 8 + Datenfeld(d + 1) * 4 + _
                  Datenfeld(d + 2) * 2 + Datenfeld(d + 3)) * 100
      If ft.Finish() Then Return
      lblStatus.Text = "Tonfrequenz : " & Frequenz
      Kode = Datenfeld(d) & Datenfeld(d + 1) & Datenfeld(d + 2) & Datenfeld(d + 3)
      lstWerte.Items.Add(Kode & "->Frequenz : " & Frequenz)
      Application.DoEvents()
      If Frequenz > 0 Then Console.Beep(Frequenz, 600) Else ft.Pause(400)
      d += 4
    Loop While d < 71
  End Sub

  Private Sub ScheibeLesen(ByVal iSpur As Integer)
    Dim Spurwerte As String = ""
    If iSpur > 0 Then
      lblStatus.Text = "Wechsel auf Spur : " & iSpur
      ft.SetMotor(mLeseSchlitten, dVor)
      ft.WaitForChange(iLesenImpuls, 26)
      ft.SetMotor(mLeseSchlitten, Dir.Aus)
    End If
    ft.SetMotor(mScheibe, Dir.Rechts)
    For i As Integer = iSpur * 25 To iSpur * 25 + 25
      Datenfeld(i) = IIf(ft.GetInput(iLeseKopf), 1, 0)
      lblStatus.Text = "Lesen bit : " & i & "  Wert : " & Datenfeld(i)
      Spurwerte += Datenfeld(i) & " "
      ft.WaitForChange(iScheibeImpuls, 16)
    Next
    ft.SetMotor(mScheibe, Dir.Aus)
    lstWerte.Items.Add("Spur : " & iSpur)
    lstWerte.Items.Add(Spurwerte)
  End Sub

#Region "--- ProgramControl ---"
  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
  Handles cmdAction.Click
    ' --- Open erste ROBO Interface an USB oder Intelligent Interface an COM ---
    '     während des Ablaufs von Action gesperrt
    Try
      If cboPortName.SelectedIndex = 0 Then
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      Else
        ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5)
      End If
      cmdAction.Enabled = False
      cmdEnde.Text = "&HALT"
      lblStatus.Text = "--- Bei der Arbeit ---"

      Action()          ' --- Nutz-Routine für die Anwendung

      ft.ClearMotors()
    Catch ex As FishFaceException
      MsgBox(ex.Message)
    Finally
      ft.CloseInterface()
      cmdAction.Enabled = True
      cmdEnde.Text = "&ENDE"
      lblStatus.Text = "--- Auf ein Neues ---"
      cmdEnde.Focus()
    End Try

  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    ' --- Programmende nur, wenn Action nicht läuft ---
    If cmdEnde.Text = "&HALT" Then ft.NotHalt = True Else Me.Close()
  End Sub

  Private Sub ManBeispiele_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' --- Default erstes ROBO Interface an USB ---
    cboPortName.SelectedIndex = 0
  End Sub

  Private Sub ManBeispiele_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    ' --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ---
    If cmdEnde.Text = "&HALT" Then e.Cancel = True
  End Sub

#End Region
End Class
