﻿' -----------------------------------------------------------------------------------------
'
' CDMain.vb                                                         Ulrich Müller  30.12.07
'                                                                   PCS1700 VB 2005 Express
' Modell CD-Player aus Profi Computing von 1991
' die Datenscheibe hat 3 Spuren mit je 25 Segmenten = 75 Datenbits,
' nach dem Start des Programmes werden alle Daten nach Datenfeld eingelesen und dann 
' geschlossen abgespielt, dabei werden jeweils 4 bits zu einem Ton zusammengefaßt.
' So sind 15 verschiedene Töne und Ruhe möglich.
' --- Basis ist die Assembly FishFace2005.DLL
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFace40

Public Class CDPlayerOrig

  Dim ft As New FishFace()
  Dim Datenfeld(75) As Boolean

  Private Sub Action()
    CDInit()
    ScheibeLesen()
    TonfolgeErzeugen()
  End Sub

  Private Sub CDInit()
    ft.SetMotor(Out.M3, Dir.Ein)
    ft.SetMotor(Out.M1, Dir.Rechts)
    ft.SetMotor(Out.M2, Dir.Links)
    ft.WaitForInput(Inp.I4, False)
    ft.SetMotor(Out.M2, Dir.Rechts)
    ft.WaitForInput(Inp.I4)
    ft.SetMotor(Out.M2, Dir.Aus)
    ft.WaitForHigh(Inp.I1)
    For i As Integer = 0 To Datenfeld.Length - 1
      Datenfeld(i) = False
    Next
  End Sub

  Private Sub ScheibeLesen()
    For i As Integer = 0 To 24
      Datenfeld(i) = Not ft.GetInput(Inp.I5)
      ft.WaitForChange(Inp.I2, 16)
    Next
    ft.SetMotor(Out.M1, Dir.Aus)

    ft.SetMotor(Out.M2, Dir.Links)
    ft.WaitForChange(Inp.I3, 26)
    ft.SetMotor(Out.M2, Dir.Aus)

    ft.SetMotor(Out.M1, Dir.Rechts)
    For i As Integer = 25 To 49
      Datenfeld(i) = Not ft.GetInput(Inp.I5)
      ft.WaitForChange(Inp.I2, 16)
    Next
    ft.SetMotor(Out.M1, Dir.Aus)

    ft.SetMotor(Out.M2, Dir.Links)
    ft.WaitForChange(Inp.I3, 26)
    ft.SetMotor(Out.M2, Dir.Aus)

    ft.SetMotor(Out.M1, Dir.Rechts)
    For i As Integer = 50 To 74
      Datenfeld(i) = Not ft.GetInput(Inp.I5)
      ft.WaitForChange(Inp.I2, 16)
    Next
    ft.SetMotor(Out.M1, Dir.Aus)

    ft.SetMotor(Out.M1, Dir.Aus)
    ft.SetMotor(Out.M3, Dir.Aus)
    ft.SetMotor(Out.M2, Dir.Rechts)
    ft.WaitForInput(Inp.I4)
    ft.SetMotor(Out.M2, Dir.Aus)
  End Sub

  Private Sub TonfolgeErzeugen()
    Dim Frequenz As Integer
    Dim i As Integer = 0
    Do
      Frequenz = 0
      If Datenfeld(i) Then Frequenz += 8
      If Datenfeld(i + 1) Then Frequenz += 4
      If Datenfeld(i + 2) Then Frequenz += 2
      If Datenfeld(i + 3) Then Frequenz += 1
      If ft.Finish() Then Return
      If Frequenz > 0 Then Console.Beep(Frequenz * 100, 600) Else ft.Pause(400)
      i += 4
    Loop While i < 71
  End Sub

#Region "--- ProgramControl ---"
  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
  Handles cmdAction.Click
    ' --- Open erste ROBO Interface an USB oder Intelligent Interface an COM ---
    '     während des Ablaufs von Action gesperrt
    Try
      If cboPortName.SelectedIndex = 0 Then
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      Else
        ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5)
      End If
      cmdAction.Enabled = False
      cmdEnde.Text = "&HALT"
      lblStatus.Text = "--- Bei der Arbeit ---"

      Action()          ' --- Nutz-Routine für die Anwendung

      ft.ClearMotors()
    Catch ex As FishFaceException
      MsgBox(ex.Message)
    Finally
      ft.CloseInterface()
      cmdAction.Enabled = True
      cmdEnde.Text = "&ENDE"
      lblStatus.Text = "--- Auf ein Neues ---"
      cmdEnde.Focus()
    End Try

  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    ' --- Programmende nur, wenn Action nicht läuft ---
    If cmdEnde.Text = "&HALT" Then ft.NotHalt = True Else Me.Close()
  End Sub

  Private Sub ManBeispiele_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' --- Default erstes ROBO Interface an USB ---
    cboPortName.SelectedIndex = 0
  End Sub

  Private Sub ManBeispiele_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    ' --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ---
    If cmdEnde.Text = "&HALT" Then e.Cancel = True
  End Sub

#End Region
End Class
